
/*
 * This is a small bit of C that will pull the MAC address from a given network
 * device and send it to STDOUT.
 *
 * Original code by (or found) Lance Davis, hacked for argument support and
 * other minors by Greg Kurtzer <greg@caosity.org> for cinch.
 *
*/

#include <stdio.h>              /* standard I/O */
#include <errno.h>              /* error numbers */
#include <sys/socket.h>         /* socket definitions */
#include <sys/ioctl.h>          /* ioctls */
#include <net/if.h>             /* generic interface structures */
                                                                                
int main( int argc, char *argv[] )
{
  int s;
  struct  ifreq  devea;

  if(argc==2) {
     strcpy(devea.ifr_name,argv[1]);
  } else {
     printf("Usage: %s device\n",argv[0]);
     exit(1);
  }

  s = socket(AF_INET,SOCK_DGRAM,0);
  if (s < 0) {
     perror("socket");
     exit(1);
  }
                                                                                
                                                                                
  if (ioctl(s,SIOCGIFHWADDR,&devea) < 0) {
     perror(&devea.ifr_name[0]);
     exit(1);
  }

  printf("%.2X:", devea.ifr_ifru.ifru_hwaddr.sa_data[0]&0xff);
  printf("%.2X:", devea.ifr_ifru.ifru_hwaddr.sa_data[1]&0xff);
  printf("%.2X:", devea.ifr_ifru.ifru_hwaddr.sa_data[2]&0xff);
  printf("%.2X:", devea.ifr_ifru.ifru_hwaddr.sa_data[3]&0xff);
  printf("%.2X:", devea.ifr_ifru.ifru_hwaddr.sa_data[4]&0xff);
  printf("%.2X\n", devea.ifr_ifru.ifru_hwaddr.sa_data[5]&0xff);
                                                                                
  return (0);
}

